-- Copyright (C) 2009-2010 John Millikin <jmillikin@gmail.com>
-- 
-- This program is free software: you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation, either version 3 of the License, or
-- any later version.
-- 
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
-- 
-- You should have received a copy of the GNU General Public License
-- along with this program.  If not, see <http://www.gnu.org/licenses/>.
module DBus.Types (
	  -- * Available types
	  Type (..)
	, typeCode
	  -- * Variants
	, Variant
	, Variable (..)
	, variantType
	  -- * Signatures
	, Signature
	, signatureTypes
	, strSignature
	, mkSignature
	, mkSignature_
	  -- * Object paths
	, ObjectPath
	, strObjectPath
	, mkObjectPath
	, mkObjectPath_
	  -- * Arrays
	, Array
	, arrayType
	, arrayItems
	, toArray
	, fromArray
	, arrayFromItems
	, arrayToBytes
	, arrayFromBytes
	  -- * Dictionaries
	, Dictionary
	, dictionaryItems
	, dictionaryKeyType
	, dictionaryValueType
	, toDictionary
	, fromDictionary
	, dictionaryFromItems
	, dictionaryToArray
	, arrayToDictionary
	  -- * Structures
	, Structure (..)
	-- * Names
	  -- ** Bus names
	, BusName
	, strBusName
	, mkBusName
	, mkBusName_
	  -- ** Interface names
	, InterfaceName
	, strInterfaceName
	, mkInterfaceName
	, mkInterfaceName_
	  -- ** Error names
	, ErrorName
	, strErrorName
	, mkErrorName
	, mkErrorName_
	  -- ** Member names
	, MemberName
	, strMemberName
	, mkMemberName
	, mkMemberName_
	) where
import DBus.Types.Internal
